// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from game_controller_spl_interfaces:msg/RobotInfo14.idl
// generated code does not contain a copyright notice

#ifndef GAME_CONTROLLER_SPL_INTERFACES__MSG__DETAIL__ROBOT_INFO14__TRAITS_HPP_
#define GAME_CONTROLLER_SPL_INTERFACES__MSG__DETAIL__ROBOT_INFO14__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "game_controller_spl_interfaces/msg/detail/robot_info14__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace game_controller_spl_interfaces
{

namespace msg
{

inline void to_flow_style_yaml(
  const RobotInfo14 & msg,
  std::ostream & out)
{
  out << "{";
  // member: penalty
  {
    out << "penalty: ";
    rosidl_generator_traits::value_to_yaml(msg.penalty, out);
    out << ", ";
  }

  // member: secs_till_unpenalised
  {
    out << "secs_till_unpenalised: ";
    rosidl_generator_traits::value_to_yaml(msg.secs_till_unpenalised, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const RobotInfo14 & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: penalty
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "penalty: ";
    rosidl_generator_traits::value_to_yaml(msg.penalty, out);
    out << "\n";
  }

  // member: secs_till_unpenalised
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "secs_till_unpenalised: ";
    rosidl_generator_traits::value_to_yaml(msg.secs_till_unpenalised, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const RobotInfo14 & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace game_controller_spl_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use game_controller_spl_interfaces::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const game_controller_spl_interfaces::msg::RobotInfo14 & msg,
  std::ostream & out, size_t indentation = 0)
{
  game_controller_spl_interfaces::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use game_controller_spl_interfaces::msg::to_yaml() instead")]]
inline std::string to_yaml(const game_controller_spl_interfaces::msg::RobotInfo14 & msg)
{
  return game_controller_spl_interfaces::msg::to_yaml(msg);
}

template<>
inline const char * data_type<game_controller_spl_interfaces::msg::RobotInfo14>()
{
  return "game_controller_spl_interfaces::msg::RobotInfo14";
}

template<>
inline const char * name<game_controller_spl_interfaces::msg::RobotInfo14>()
{
  return "game_controller_spl_interfaces/msg/RobotInfo14";
}

template<>
struct has_fixed_size<game_controller_spl_interfaces::msg::RobotInfo14>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<game_controller_spl_interfaces::msg::RobotInfo14>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<game_controller_spl_interfaces::msg::RobotInfo14>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // GAME_CONTROLLER_SPL_INTERFACES__MSG__DETAIL__ROBOT_INFO14__TRAITS_HPP_
