// generated from rosidl_generator_cpp/resource/idl__builder.hpp.em
// with input from game_controller_spl_interfaces:msg/TeamInfo16.idl
// generated code does not contain a copyright notice

#ifndef GAME_CONTROLLER_SPL_INTERFACES__MSG__DETAIL__TEAM_INFO16__BUILDER_HPP_
#define GAME_CONTROLLER_SPL_INTERFACES__MSG__DETAIL__TEAM_INFO16__BUILDER_HPP_

#include <algorithm>
#include <utility>

#include "game_controller_spl_interfaces/msg/detail/team_info16__struct.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


namespace game_controller_spl_interfaces
{

namespace msg
{

namespace builder
{

class Init_TeamInfo16_players
{
public:
  explicit Init_TeamInfo16_players(::game_controller_spl_interfaces::msg::TeamInfo16 & msg)
  : msg_(msg)
  {}
  ::game_controller_spl_interfaces::msg::TeamInfo16 players(::game_controller_spl_interfaces::msg::TeamInfo16::_players_type arg)
  {
    msg_.players = std::move(arg);
    return std::move(msg_);
  }

private:
  ::game_controller_spl_interfaces::msg::TeamInfo16 msg_;
};

class Init_TeamInfo16_message_budget
{
public:
  explicit Init_TeamInfo16_message_budget(::game_controller_spl_interfaces::msg::TeamInfo16 & msg)
  : msg_(msg)
  {}
  Init_TeamInfo16_players message_budget(::game_controller_spl_interfaces::msg::TeamInfo16::_message_budget_type arg)
  {
    msg_.message_budget = std::move(arg);
    return Init_TeamInfo16_players(msg_);
  }

private:
  ::game_controller_spl_interfaces::msg::TeamInfo16 msg_;
};

class Init_TeamInfo16_single_shots
{
public:
  explicit Init_TeamInfo16_single_shots(::game_controller_spl_interfaces::msg::TeamInfo16 & msg)
  : msg_(msg)
  {}
  Init_TeamInfo16_message_budget single_shots(::game_controller_spl_interfaces::msg::TeamInfo16::_single_shots_type arg)
  {
    msg_.single_shots = std::move(arg);
    return Init_TeamInfo16_message_budget(msg_);
  }

private:
  ::game_controller_spl_interfaces::msg::TeamInfo16 msg_;
};

class Init_TeamInfo16_penalty_shot
{
public:
  explicit Init_TeamInfo16_penalty_shot(::game_controller_spl_interfaces::msg::TeamInfo16 & msg)
  : msg_(msg)
  {}
  Init_TeamInfo16_single_shots penalty_shot(::game_controller_spl_interfaces::msg::TeamInfo16::_penalty_shot_type arg)
  {
    msg_.penalty_shot = std::move(arg);
    return Init_TeamInfo16_single_shots(msg_);
  }

private:
  ::game_controller_spl_interfaces::msg::TeamInfo16 msg_;
};

class Init_TeamInfo16_score
{
public:
  explicit Init_TeamInfo16_score(::game_controller_spl_interfaces::msg::TeamInfo16 & msg)
  : msg_(msg)
  {}
  Init_TeamInfo16_penalty_shot score(::game_controller_spl_interfaces::msg::TeamInfo16::_score_type arg)
  {
    msg_.score = std::move(arg);
    return Init_TeamInfo16_penalty_shot(msg_);
  }

private:
  ::game_controller_spl_interfaces::msg::TeamInfo16 msg_;
};

class Init_TeamInfo16_team_colour
{
public:
  explicit Init_TeamInfo16_team_colour(::game_controller_spl_interfaces::msg::TeamInfo16 & msg)
  : msg_(msg)
  {}
  Init_TeamInfo16_score team_colour(::game_controller_spl_interfaces::msg::TeamInfo16::_team_colour_type arg)
  {
    msg_.team_colour = std::move(arg);
    return Init_TeamInfo16_score(msg_);
  }

private:
  ::game_controller_spl_interfaces::msg::TeamInfo16 msg_;
};

class Init_TeamInfo16_goalkeeper
{
public:
  explicit Init_TeamInfo16_goalkeeper(::game_controller_spl_interfaces::msg::TeamInfo16 & msg)
  : msg_(msg)
  {}
  Init_TeamInfo16_team_colour goalkeeper(::game_controller_spl_interfaces::msg::TeamInfo16::_goalkeeper_type arg)
  {
    msg_.goalkeeper = std::move(arg);
    return Init_TeamInfo16_team_colour(msg_);
  }

private:
  ::game_controller_spl_interfaces::msg::TeamInfo16 msg_;
};

class Init_TeamInfo16_goalkeeper_colour
{
public:
  explicit Init_TeamInfo16_goalkeeper_colour(::game_controller_spl_interfaces::msg::TeamInfo16 & msg)
  : msg_(msg)
  {}
  Init_TeamInfo16_goalkeeper goalkeeper_colour(::game_controller_spl_interfaces::msg::TeamInfo16::_goalkeeper_colour_type arg)
  {
    msg_.goalkeeper_colour = std::move(arg);
    return Init_TeamInfo16_goalkeeper(msg_);
  }

private:
  ::game_controller_spl_interfaces::msg::TeamInfo16 msg_;
};

class Init_TeamInfo16_field_player_colour
{
public:
  explicit Init_TeamInfo16_field_player_colour(::game_controller_spl_interfaces::msg::TeamInfo16 & msg)
  : msg_(msg)
  {}
  Init_TeamInfo16_goalkeeper_colour field_player_colour(::game_controller_spl_interfaces::msg::TeamInfo16::_field_player_colour_type arg)
  {
    msg_.field_player_colour = std::move(arg);
    return Init_TeamInfo16_goalkeeper_colour(msg_);
  }

private:
  ::game_controller_spl_interfaces::msg::TeamInfo16 msg_;
};

class Init_TeamInfo16_team_number
{
public:
  Init_TeamInfo16_team_number()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_TeamInfo16_field_player_colour team_number(::game_controller_spl_interfaces::msg::TeamInfo16::_team_number_type arg)
  {
    msg_.team_number = std::move(arg);
    return Init_TeamInfo16_field_player_colour(msg_);
  }

private:
  ::game_controller_spl_interfaces::msg::TeamInfo16 msg_;
};

}  // namespace builder

}  // namespace msg

template<typename MessageType>
auto build();

template<>
inline
auto build<::game_controller_spl_interfaces::msg::TeamInfo16>()
{
  return game_controller_spl_interfaces::msg::builder::Init_TeamInfo16_team_number();
}

}  // namespace game_controller_spl_interfaces

#endif  // GAME_CONTROLLER_SPL_INTERFACES__MSG__DETAIL__TEAM_INFO16__BUILDER_HPP_
