// generated from rosidl_generator_cpp/resource/idl__builder.hpp.em
// with input from game_controller_spl_interfaces:msg/RCGCD16.idl
// generated code does not contain a copyright notice

#ifndef GAME_CONTROLLER_SPL_INTERFACES__MSG__DETAIL__RCGCD16__BUILDER_HPP_
#define GAME_CONTROLLER_SPL_INTERFACES__MSG__DETAIL__RCGCD16__BUILDER_HPP_

#include <algorithm>
#include <utility>

#include "game_controller_spl_interfaces/msg/detail/rcgcd16__struct.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


namespace game_controller_spl_interfaces
{

namespace msg
{

namespace builder
{

class Init_RCGCD16_teams
{
public:
  explicit Init_RCGCD16_teams(::game_controller_spl_interfaces::msg::RCGCD16 & msg)
  : msg_(msg)
  {}
  ::game_controller_spl_interfaces::msg::RCGCD16 teams(::game_controller_spl_interfaces::msg::RCGCD16::_teams_type arg)
  {
    msg_.teams = std::move(arg);
    return std::move(msg_);
  }

private:
  ::game_controller_spl_interfaces::msg::RCGCD16 msg_;
};

class Init_RCGCD16_secondary_time
{
public:
  explicit Init_RCGCD16_secondary_time(::game_controller_spl_interfaces::msg::RCGCD16 & msg)
  : msg_(msg)
  {}
  Init_RCGCD16_teams secondary_time(::game_controller_spl_interfaces::msg::RCGCD16::_secondary_time_type arg)
  {
    msg_.secondary_time = std::move(arg);
    return Init_RCGCD16_teams(msg_);
  }

private:
  ::game_controller_spl_interfaces::msg::RCGCD16 msg_;
};

class Init_RCGCD16_secs_remaining
{
public:
  explicit Init_RCGCD16_secs_remaining(::game_controller_spl_interfaces::msg::RCGCD16 & msg)
  : msg_(msg)
  {}
  Init_RCGCD16_secondary_time secs_remaining(::game_controller_spl_interfaces::msg::RCGCD16::_secs_remaining_type arg)
  {
    msg_.secs_remaining = std::move(arg);
    return Init_RCGCD16_secondary_time(msg_);
  }

private:
  ::game_controller_spl_interfaces::msg::RCGCD16 msg_;
};

class Init_RCGCD16_kicking_team
{
public:
  explicit Init_RCGCD16_kicking_team(::game_controller_spl_interfaces::msg::RCGCD16 & msg)
  : msg_(msg)
  {}
  Init_RCGCD16_secs_remaining kicking_team(::game_controller_spl_interfaces::msg::RCGCD16::_kicking_team_type arg)
  {
    msg_.kicking_team = std::move(arg);
    return Init_RCGCD16_secs_remaining(msg_);
  }

private:
  ::game_controller_spl_interfaces::msg::RCGCD16 msg_;
};

class Init_RCGCD16_first_half
{
public:
  explicit Init_RCGCD16_first_half(::game_controller_spl_interfaces::msg::RCGCD16 & msg)
  : msg_(msg)
  {}
  Init_RCGCD16_kicking_team first_half(::game_controller_spl_interfaces::msg::RCGCD16::_first_half_type arg)
  {
    msg_.first_half = std::move(arg);
    return Init_RCGCD16_kicking_team(msg_);
  }

private:
  ::game_controller_spl_interfaces::msg::RCGCD16 msg_;
};

class Init_RCGCD16_set_play
{
public:
  explicit Init_RCGCD16_set_play(::game_controller_spl_interfaces::msg::RCGCD16 & msg)
  : msg_(msg)
  {}
  Init_RCGCD16_first_half set_play(::game_controller_spl_interfaces::msg::RCGCD16::_set_play_type arg)
  {
    msg_.set_play = std::move(arg);
    return Init_RCGCD16_first_half(msg_);
  }

private:
  ::game_controller_spl_interfaces::msg::RCGCD16 msg_;
};

class Init_RCGCD16_state
{
public:
  explicit Init_RCGCD16_state(::game_controller_spl_interfaces::msg::RCGCD16 & msg)
  : msg_(msg)
  {}
  Init_RCGCD16_set_play state(::game_controller_spl_interfaces::msg::RCGCD16::_state_type arg)
  {
    msg_.state = std::move(arg);
    return Init_RCGCD16_set_play(msg_);
  }

private:
  ::game_controller_spl_interfaces::msg::RCGCD16 msg_;
};

class Init_RCGCD16_game_phase
{
public:
  explicit Init_RCGCD16_game_phase(::game_controller_spl_interfaces::msg::RCGCD16 & msg)
  : msg_(msg)
  {}
  Init_RCGCD16_state game_phase(::game_controller_spl_interfaces::msg::RCGCD16::_game_phase_type arg)
  {
    msg_.game_phase = std::move(arg);
    return Init_RCGCD16_state(msg_);
  }

private:
  ::game_controller_spl_interfaces::msg::RCGCD16 msg_;
};

class Init_RCGCD16_competition_type
{
public:
  explicit Init_RCGCD16_competition_type(::game_controller_spl_interfaces::msg::RCGCD16 & msg)
  : msg_(msg)
  {}
  Init_RCGCD16_game_phase competition_type(::game_controller_spl_interfaces::msg::RCGCD16::_competition_type_type arg)
  {
    msg_.competition_type = std::move(arg);
    return Init_RCGCD16_game_phase(msg_);
  }

private:
  ::game_controller_spl_interfaces::msg::RCGCD16 msg_;
};

class Init_RCGCD16_competition_phase
{
public:
  explicit Init_RCGCD16_competition_phase(::game_controller_spl_interfaces::msg::RCGCD16 & msg)
  : msg_(msg)
  {}
  Init_RCGCD16_competition_type competition_phase(::game_controller_spl_interfaces::msg::RCGCD16::_competition_phase_type arg)
  {
    msg_.competition_phase = std::move(arg);
    return Init_RCGCD16_competition_type(msg_);
  }

private:
  ::game_controller_spl_interfaces::msg::RCGCD16 msg_;
};

class Init_RCGCD16_players_per_team
{
public:
  explicit Init_RCGCD16_players_per_team(::game_controller_spl_interfaces::msg::RCGCD16 & msg)
  : msg_(msg)
  {}
  Init_RCGCD16_competition_phase players_per_team(::game_controller_spl_interfaces::msg::RCGCD16::_players_per_team_type arg)
  {
    msg_.players_per_team = std::move(arg);
    return Init_RCGCD16_competition_phase(msg_);
  }

private:
  ::game_controller_spl_interfaces::msg::RCGCD16 msg_;
};

class Init_RCGCD16_packet_number
{
public:
  Init_RCGCD16_packet_number()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_RCGCD16_players_per_team packet_number(::game_controller_spl_interfaces::msg::RCGCD16::_packet_number_type arg)
  {
    msg_.packet_number = std::move(arg);
    return Init_RCGCD16_players_per_team(msg_);
  }

private:
  ::game_controller_spl_interfaces::msg::RCGCD16 msg_;
};

}  // namespace builder

}  // namespace msg

template<typename MessageType>
auto build();

template<>
inline
auto build<::game_controller_spl_interfaces::msg::RCGCD16>()
{
  return game_controller_spl_interfaces::msg::builder::Init_RCGCD16_packet_number();
}

}  // namespace game_controller_spl_interfaces

#endif  // GAME_CONTROLLER_SPL_INTERFACES__MSG__DETAIL__RCGCD16__BUILDER_HPP_
