// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from game_controller_spl_interfaces:msg/RCGCD16.idl
// generated code does not contain a copyright notice

#ifndef GAME_CONTROLLER_SPL_INTERFACES__MSG__DETAIL__RCGCD16__STRUCT_H_
#define GAME_CONTROLLER_SPL_INTERFACES__MSG__DETAIL__RCGCD16__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'COMPETITION_PHASE_ROUNDROBIN'.
enum
{
  game_controller_spl_interfaces__msg__RCGCD16__COMPETITION_PHASE_ROUNDROBIN = 0
};

/// Constant 'COMPETITION_PHASE_PLAYOFF'.
enum
{
  game_controller_spl_interfaces__msg__RCGCD16__COMPETITION_PHASE_PLAYOFF = 1
};

/// Constant 'COMPETITION_TYPE_NORMAL'.
enum
{
  game_controller_spl_interfaces__msg__RCGCD16__COMPETITION_TYPE_NORMAL = 0
};

/// Constant 'COMPETITION_TYPE_SHARED_AUTONOMY'.
enum
{
  game_controller_spl_interfaces__msg__RCGCD16__COMPETITION_TYPE_SHARED_AUTONOMY = 1
};

/// Constant 'GAME_PHASE_NORMAL'.
enum
{
  game_controller_spl_interfaces__msg__RCGCD16__GAME_PHASE_NORMAL = 0
};

/// Constant 'GAME_PHASE_PENALTYSHOOT'.
enum
{
  game_controller_spl_interfaces__msg__RCGCD16__GAME_PHASE_PENALTYSHOOT = 1
};

/// Constant 'GAME_PHASE_OVERTIME'.
enum
{
  game_controller_spl_interfaces__msg__RCGCD16__GAME_PHASE_OVERTIME = 2
};

/// Constant 'GAME_PHASE_TIMEOUT'.
enum
{
  game_controller_spl_interfaces__msg__RCGCD16__GAME_PHASE_TIMEOUT = 3
};

/// Constant 'STATE_INITIAL'.
enum
{
  game_controller_spl_interfaces__msg__RCGCD16__STATE_INITIAL = 0
};

/// Constant 'STATE_READY'.
enum
{
  game_controller_spl_interfaces__msg__RCGCD16__STATE_READY = 1
};

/// Constant 'STATE_SET'.
enum
{
  game_controller_spl_interfaces__msg__RCGCD16__STATE_SET = 2
};

/// Constant 'STATE_PLAYING'.
enum
{
  game_controller_spl_interfaces__msg__RCGCD16__STATE_PLAYING = 3
};

/// Constant 'STATE_FINISHED'.
enum
{
  game_controller_spl_interfaces__msg__RCGCD16__STATE_FINISHED = 4
};

/// Constant 'SET_PLAY_NONE'.
enum
{
  game_controller_spl_interfaces__msg__RCGCD16__SET_PLAY_NONE = 0
};

/// Constant 'SET_PLAY_GOAL_KICK'.
enum
{
  game_controller_spl_interfaces__msg__RCGCD16__SET_PLAY_GOAL_KICK = 1
};

/// Constant 'SET_PLAY_PUSHING_FREE_KICK'.
enum
{
  game_controller_spl_interfaces__msg__RCGCD16__SET_PLAY_PUSHING_FREE_KICK = 2
};

/// Constant 'SET_PLAY_CORNER_KICK'.
enum
{
  game_controller_spl_interfaces__msg__RCGCD16__SET_PLAY_CORNER_KICK = 3
};

/// Constant 'SET_PLAY_KICK_IN'.
enum
{
  game_controller_spl_interfaces__msg__RCGCD16__SET_PLAY_KICK_IN = 4
};

/// Constant 'SET_PLAY_PENALTY_KICK'.
enum
{
  game_controller_spl_interfaces__msg__RCGCD16__SET_PLAY_PENALTY_KICK = 5
};

// Include directives for member types
// Member 'teams'
#include "game_controller_spl_interfaces/msg/detail/team_info15__struct.h"

/// Struct defined in msg/RCGCD16 in the package game_controller_spl_interfaces.
typedef struct game_controller_spl_interfaces__msg__RCGCD16
{
  uint8_t packet_number;
  uint8_t players_per_team;
  uint8_t competition_phase;
  uint8_t competition_type;
  uint8_t game_phase;
  uint8_t state;
  uint8_t set_play;
  uint8_t first_half;
  uint8_t kicking_team;
  int16_t secs_remaining;
  int16_t secondary_time;
  game_controller_spl_interfaces__msg__TeamInfo15 teams[2];
} game_controller_spl_interfaces__msg__RCGCD16;

// Struct for a sequence of game_controller_spl_interfaces__msg__RCGCD16.
typedef struct game_controller_spl_interfaces__msg__RCGCD16__Sequence
{
  game_controller_spl_interfaces__msg__RCGCD16 * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} game_controller_spl_interfaces__msg__RCGCD16__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // GAME_CONTROLLER_SPL_INTERFACES__MSG__DETAIL__RCGCD16__STRUCT_H_
